/*
 * Filename: AlunoProg2.cpp
 * Author: Antonio Pereira
 */

#include <iostream>

#include "AlunoProg2.h"

using std::cout;
using std::endl;

AlunoProg2::AlunoProg2() {
  mNumero = 0;
  mNome = "";
  for (int i = 0; i < 4; i++) {
    mNotaAP[i] = 0;
    mNotaAQ[i] = 0;
    if (i < 2)
      mNotaMT[i] = 0;
  }
}

AlunoProg2::AlunoProg2(int numero, string nome) {
  mNumero = numero;
  mNome = nome;
  for (int i = 0; i < 4; i++) {
    mNotaAP[i] = 0;
    mNotaAQ[i] = 0;
    if (i < 2)
      mNotaMT[i] = 0;
  }
}
  
void AlunoProg2::notaAP(int iProva, float nota) {
  if (iProva < 1 || iProva > 4)
    return;

  if (nota < 0 || nota > 100)
    return;

  mNotaAP[iProva - 1] = nota;
}
  
void AlunoProg2::notaAQ(int iProva, float nota) {
  if (iProva < 1 || iProva > 4)
    return;

  if (nota < 0 || nota > 100)
    return;

  mNotaAQ[iProva - 1] = nota;
}
  
void AlunoProg2::notaMT(int iProva, float nota) {
  if (iProva < 1 || iProva > 2)
    return;

  if (nota < 0 || nota > 100)
    return;

  mNotaMT[iProva - 1] = nota;
}

void AlunoProg2::nome(string name) {
  mNome = name;
}

void AlunoProg2::numero(int nr) {
  mNumero = nr;
}

float AlunoProg2::notaAP(int iProva) {
  if (iProva < 1 || iProva > 4)
    return -1;

  return mNotaAP[iProva - 1];
}

float AlunoProg2::notaAQ(int iProva) {
  if (iProva < 1 || iProva > 4)
    return -1;

  return mNotaAQ[iProva - 1];
}

float AlunoProg2::notaMT(int iProva) {
  if (iProva < 1 || iProva > 2)
    return -1;

  return mNotaMT[iProva - 1];
}

string AlunoProg2::nome() {
  return mNome;
}

int AlunoProg2::numero() {
  return mNumero;
}

float AlunoProg2::notaFinal() {
  float minAP = mNotaAP[0];
  float minAQ = mNotaAQ[0];
  float somaAP = 0;
  float somaAQ = 0;
  
  for (int i = 0; i < 4; i++) {
    if (mNotaAP[i] < minAP)
      minAP = mNotaAP[i];
    somaAP += mNotaAP[i];
    
    if (mNotaAQ[i] < minAQ)
      minAQ = mNotaAQ[i];
    somaAQ += mNotaAQ[i];
  }

  float nFreq = (2 * (somaAP - minAP) / 3 + (somaAQ - minAQ) / 3) / 3;
  float nMT = (mNotaMT[0] + mNotaMT[1]) / 2;

  if (nFreq < 30 || nMT < 30)   // 30% = 6.0 valores
    return 5.0;

  float nFinal = (nFreq * 6 + nMT * 4) / 10;
  return (nFinal * 20) / 100;
}

void AlunoProg2::printAluno() {
  cout << "Nome: " << mNome << endl
      << "Numero: " << mNumero << endl
      << "AP1 = " << mNotaAP[0] << "; AP2 = " << mNotaAP[1] << "; "
      << "AP3 = " << mNotaAP[2] << "; AP4 = " << mNotaAP[3] << endl
      << "AQ1 = " << mNotaAQ[0] << "; AQ2 = " << mNotaAQ[1] << "; " 
      << "AQ3 = " << mNotaAQ[2] << "; AQ4 = " << mNotaAQ[3] << endl
      << "MT1 = " << mNotaMT[0] << "; MT2 = " << mNotaMT[1] << endl 
      << "Nota Final = " << notaFinal() << endl;
}
