/*
 * Filename: gestaoProg2.cpp
 * Author: Antonio Pereira
 */

#include <iostream>
#include <vector>

#include "AlunoProg2.h"

using std::cin;
using std::cout;
using std::endl;
using std::vector;


vector<AlunoProg2 *> alunos;

AlunoProg2 *getAluno() {
  string input;
  string nome;
  int numero;

  cout << "Nome ou numero do aluno: " ; 
  cin >> nome;
  getline(cin, input);
  nome += input;
  numero = atoi(nome.c_str());

  for (int i = 0; i < alunos.size(); i++) {
    if (numero != 0) {
      if (alunos[i]->numero() == numero)
        return alunos[i];
    }
    else {
      if (alunos[i]->nome() == nome)
        return alunos[i];
    }
  }
  return NULL; 
}

bool getDadosAluno(const string &questao, AlunoProg2* &ap2, int &prova) {
  string input;

  ap2 = getAluno();
  if (ap2 != NULL) {
    cout << questao;
    cin >> input;
    prova = atoi(input.c_str());
    return true;
  }
  return false;
}

bool getDadosAluno(const string &questao, AlunoProg2* &ap2, int &prova, float &nota) {
  string input;

  ap2 = getAluno();
  if (ap2 != NULL) {
    cout << questao;
    cin >> input;
    prova = atoi(input.c_str());
    cout << "Nota (0-100 %): ";
    cin >> input;
    nota = atof(input.c_str());
    return true;
  }
  return false;
}
 
void printWelcome() {
  cout << "\nPrograma para gestao de alunos de Programacao 2" << endl << endl;
}

int readOpcao() {
  string op;

  cout << "\n\nIntroduza a opcao que deseja" << endl << endl;
  cout << "  1. Inserir aluno" << endl;
  cout << "  2. Inserir nota AP" << endl;
  cout << "  3. Inserir nota AQ" << endl;
  cout << "  4. Inserir nota MT" << endl;
  cout << "  5. Ver nota AP" << endl;
  cout << "  6. Ver nota AQ" << endl;
  cout << "  7. Ver nota MT" << endl;
  cout << "  8. Ver nota final" << endl;
  cout << "  9. Ver nota final de todos os alunos" << endl;
  cout << endl << "  0. Sair" << endl << endl << "? " ;
  cin >> op;
  return atoi(op.c_str());

}

int main(int argc, char* argv[]) {
  int opcao;

  printWelcome();
  while((opcao = readOpcao()) != 0) {
    switch (opcao) {
      case 1:
        {
          string nome, nome2;
          int numero;
          cout << "Nome: "; 
          cin >> nome;
          getline(cin, nome2);
          nome += nome2;
          cout << "Numero: ";
          cin >> numero;
          AlunoProg2 *aluno = new AlunoProg2(numero, nome);
          alunos.push_back(aluno);
          aluno->printAluno();
        }
        break;

      case 2:
        {
          int prova;
          float nota;
          AlunoProg2 *ap2;
          if (getDadosAluno("Prova Pratica (1-4): ", ap2, prova, nota)) {
            ap2->notaAP(prova, nota);
            ap2->printAluno();
          }
          else {
            cout << "Aluno inexistente" << endl;
          }
        }
        break;

      case 3:
        {
          int prova;
          float nota;
          AlunoProg2 *ap2;
          if (getDadosAluno("Questionario (1-4): ", ap2, prova, nota)) {
            ap2->notaAQ(prova, nota);
            ap2->printAluno();
          }
          else {
            cout << "Aluno inexistente" << endl;
          }
        }
        break;

      case 4:
        {
          int prova;
          float nota;
          AlunoProg2 *ap2;
          if (getDadosAluno("Mini-Teste (1-2): ", ap2, prova, nota)) {
            ap2->notaMT(prova, nota);
            ap2->printAluno();
          }
          else {
            cout << "Aluno inexistente" << endl;
          }
        }
        break;

      case 5:
        {
          int prova;
          AlunoProg2 *ap2;
          if (getDadosAluno("Prova Pratica (1-4): ", ap2, prova)) {
            cout << "Nota = " << ap2->notaAP(prova) << endl;
            ap2->printAluno();
          }
          else {
            cout << "Aluno inexistente" << endl;
          }
        }
        break;

      case 6:
        {
          int prova;
          AlunoProg2 *ap2;
          if (getDadosAluno("Questionrio (1-4): ", ap2, prova)) {
            cout << "Nota = " << ap2->notaAQ(prova) << endl;
            ap2->printAluno();
          }
          else {
            cout << "Aluno inexistente" << endl;
          }
        }
        break;

      case 7:
        {
          int prova;
          AlunoProg2 *ap2;
          if (getDadosAluno("Mini-Teste (1-2): ", ap2, prova)) {
            cout << "Nota = " << ap2->notaMT(prova) << endl;
            ap2->printAluno();
          }
          else {
            cout << "Aluno inexistente" << endl;
          }
        }
        break;

      case 8:
        {
          int prova;
          AlunoProg2 *ap2 = getAluno();
          if (ap2 != NULL) {
            cout << "Nota Final = " << ap2->notaFinal() << endl;
            ap2->printAluno();
          }
          else {
            cout << "Aluno inexistente" << endl;
          }
        }
        break;

      case 9:
        {
          for (int i = 0; i < alunos.size(); i++) {
            if (alunos[i]->numero() != 0) {
              alunos[i]->printAluno();
              cout << (alunos[i]->notaFinal() > 9.5 ? "APROVADO" : "REPROVADO") << endl << endl;
            }
          }
        }
        break;

      default: 
        cout << "    Opcao escolhida nao valida\n" << endl;
        break;
    }
  }
}

  
